#NoTrayIcon
#include <INet.au3>

; Settings
Opt("TCPTimeout", 250)
Global $myip = _GetIP()
Local $ports_tcp[1] = [80] ; http server
Local $ports_udp[1] = [53] ; dns server
Local $ports_passed[2] = [0, 0]
Local $ports_failed[2] = [0, 0]
Local $range_check = 1

; Scan TCP ports...
TCPStartup()
For $i=0 To UBound($ports_tcp)-1
	If CheckTCP($ports_tcp[$i]) Then
		$ports_passed[0] = $ports_passed[0] + 1
	Else
		$ports_failed[0] = $ports_failed[0] + 1
	EndIf
Next
TCPShutdown()

; Scan UDP ports...
UDPStartup()
For $i=0 To UBound($ports_udp)-1
	If CheckUDP($ports_udp[$i]) Then
		$ports_passed[1] = $ports_passed[1] + 1
	Else
		$ports_failed[1] = $ports_failed[1] + 1
	EndIf
Next
UDPShutdown()

; Report
If $ports_failed[0] == 0 And $ports_failed[1] == 0 Then
	$conclusion = "Everything seems to be in order -good job!" & @CRLF & @CRLF & "Note: If there are still issues, perhaps another program/service is taking up port 80 (TCP)? You can't run multiple HTTP servers in the same household! Same goes for port 53 (UDP), you can only have one DNS server per household. If someone else at home runs a HTTP or DNS server this test will say everything is fine (because there was a response, but not from your server but from the other server). Just keep that in mind!"
Else
	$conclusion = "Tried to scan " & $range_check*2 & " ports but only " & $ports_passed[0]+$ports_passed[1] & " were accessible. This is most likely because of UPnP being turned off, unconfigured or you have not made the proper port forwarding/triggering configurations. Good luck properly port forwarding TCP80 and UDP53!"
EndIf
MsgBox(64, "Scan results...", "[TCP] " & $ports_passed[0] & "/" & $range_check & " ports open" &  @CRLF & "[UDP] " & $ports_passed[1] & "/" & $range_check & " ports open" & @CRLF & @CRLF & $conclusion)
Exit

; Checks TCP connectivity
Func CheckTCP($port)
	Local $status = False
	Local $serv = TCPListen("0.0.0.0", $port, 5)
	Local $clie = TCPConnect($myip, $port)
	If @error == 0 Then $status = True
	TCPCloseSocket($clie)
	TCPCloseSocket($serv)
	Return $status
EndFunc

; Checks UDP connectivity
Func CheckUDP($port)
	Local $status = False
	Local $serv = UDPBind("0.0.0.0", $port)
	Local $clie = UDPOpen($myip, $port)
	If @error == 0 Then $status = True
	UDPCloseSocket($clie)
	UDPCloseSocket($serv)
	Return $status
EndFunc
